<?php
/* utf8-marker = äöüß */

/*
 * Remotecontent_XH
 *
 * @author Olaf Penschke
 * @version 1.0  (22.03.2016)
================================================================================
olape

================================================================================ 

externe Inhalte in eine Seite einbinden
Aufruf mit:

======================================
html-Datei mit Authentifizierung einbinden
	{{{op_extern_content('https://domain.tld/userfiles/extern_content/datei.htm', '16-stelliges-AuthToken', 'fiktive_Browserkenneung', 'Art des Inhalts (txt, html, fullhtml', 'Wenn javaScript erhalten bleiben soll, dann js');}}}
		
		CURLOPT_USERAGENT, authtoken und IP der Webseite/des Server sind, für dieses Beispiel in "/userfiles/extern_content/.htaccess" als Regel für den Zugriff festgelegt.

======================================
	Druckausgabe von CMSimple einbinden (Urheberrechte beachten!!!)
		{{{op_extern_content('http://domain.tld/?IrgendeineSeite&print', '', '', 'fullhtml', 'js');}}}

	txt --> reine Textdatei
	html --> Boilerplate_XH Textblock
	fullhtml --> vollständige html-Datei (html, head, body, ...)

	js --> wenn gesetzt, wird JavaScript nicht gefiltert


================================================================================ 
*/

/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if (!defined('PLUGINLOADER')) {
    die(
        'Plugin '. basename(dirname(__FILE__))
        . ' requires a newer version of the Pluginloader. No direct access.'
    );
}

function op_extern_content($op_ext_url = '', $op_authtoken = '', $op_useragent = '', $op_sourceformat = '', $op_js = '')
{

global $plugin_cf, $plugin_tx;

$op_output = '';

//Authentifizierungtoken, wenn vorhanden, an URL anhängen
	if ($op_authtoken != '') {
		$op_ext_new_url = $op_ext_url . '?authtoken=' . $op_authtoken;
	} else {
		$op_ext_new_url = $op_ext_url;
	}


//UserAgent setzen
	if ($op_useragent == '') {
		//$op_useragent = "Mozilla/5.0 (Windows NT 5.1; rv:31.0) Gecko/20100101 Firefox/31.0";
		//$op_useragent = "Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html";		//als Googlebot 'tarnen'
		$op_useragent = 'Remotecontent_XH';
	}


//Quellformat festlegen
	if (($op_sourceformat != 'txt')
	 && ($op_sourceformat != 'html')
	 && ($op_sourceformat != 'fullhtml')) {
		$op_sourceformat = 'fullhtml';
	}


//Postdaten für Abfrage
	//$op_curl_data = '';

//Seitenaufruf
	$op_ch = curl_init();
		$op_options = array(														// http://php.net/manual/de/function.curl-setopt.php
			CURLOPT_URL            => $op_ext_new_url,								//
			CURLOPT_USERAGENT      => $op_useragent,								//
			CURLOPT_HTTPHEADER     => array('Accept-Language: de-DE,de;q=0.5'),		//
			CURLOPT_RETURNTRANSFER => true,											// return web page
			CURLOPT_HEADER         => false,										// don't return headers
			CURLOPT_FOLLOWLOCATION => true,											// follow redirects
			CURLOPT_MAXREDIRS      => 1,											// stop after x redirects
			CURLOPT_ENCODING       => "",											// handle all encodings
			//CURLOPT_AUTOREFERER    => true,										// set referer on redirect
			CURLOPT_CONNECTTIMEOUT => 5,											// timeout on connect
			CURLOPT_TIMEOUT        => 5,											// timeout on response
			//CURLOPT_POST           => 1,											// sending post data
			//CURLOPT_POSTFIELDS     => $op_curl_data,								// this are the post vars
			CURLOPT_SSL_VERIFYHOST => 2,											// false = don't verify ssl, 1 = Check the existence of a common name in the SSL peer certificate, 2 = Check the existence of a common name and also verify that it matches the hostname provided.
			CURLOPT_SSL_VERIFYPEER => true,											//
			//CURLOPT_VERBOSE        => 1,											// ausführliche Informationen
			//CURLOPT_FILE           => $file,										// Die Datei, in die der Transfer geschrieben werden soll. Standard ist STDOUT (der Browser).
			//CURLOPT_USERPWD        => loginname:passwort,							// ?
		);
		curl_setopt_array($op_ch, $op_options);
		$op_rueckgabe = curl_exec($op_ch);
		$op_curl_info = curl_getinfo($op_ch);
		curl_close($op_ch);


//Nachbearbeitung der Seite
		if (($op_curl_info['http_code'] == 200) || ($op_curl_info['http_code'] == 301)) {							// es kommt immer 200 ?
			if ($op_sourceformat == 'txt') {																		// reine Textdatei
				$op_tmp_output = nl2br($op_rueckgabe);
			} else if ($op_sourceformat == 'html') {																// Boilerplate_XH Textblock
				$op_tmp_output = $op_rueckgabe;
			} else {																								// vollständige html-Datei (html, head, body, ...)
				preg_match('#\<body[^>]*\>(.*)\<\/body\>#Uis', $op_rueckgabe, $op_rueckgabe_found); 				// nur den Inhalt zwischen <body> und </body>
				$op_tmp_output = $op_rueckgabe_found[1];
			}
			$op_tmp_output = preg_replace('#\{\{\{[^\}]*\}\}\}#', '', $op_tmp_output); 								// entfernt {{{ .... }}} z.B. {{{PLUGIN:video(..., oder {{{XH_mailform();}}}
			$op_tmp_output = preg_replace('#\#CMSimple[^\#]*\##Uis', '', $op_tmp_output);							// entfernt #CMSimple ....;# z.B. #CMSimple $druck="no";#
			$op_tmp_output = preg_replace('#\<iframe[^\>]*\>(.*)\<\/iframe\>#Uis', '',  $op_tmp_output);			// iFrames entfernen
			$op_tmp_output = preg_replace('#\<div[^\>]*\>(\s)*\<\/div\>#Uis', '',  $op_tmp_output);					// leere divs entfernen <div></div>, <div> </div>, <div class="..."></div>, ...
			$op_tmp_output = preg_replace('#\<\!\-\-(.*)\-\-\>#Uis', '', $op_tmp_output); 							// HTML Kommentare entfernen
			if (! ($op_js == 'js')) {
				$op_tmp_output = preg_replace('#\<script[^\>]*\>(.*)\<\/script\>#Uis', '', $op_tmp_output);			// entfernt JavaScript
				$op_tmp_output = preg_replace('#\<noscript[^\>]*\>(.*)\<\/noscript\>#Uis', '', $op_tmp_output);		// entfernt NoScript
			}
			$op_tmp_output = str_ireplace (array('<h4', '</h4', '<h1', '<h2', '<h3', '</h1', '</h2', '</h3'),		// Überschriftenstruktur anpassen
										   array('<h5', '</h5', '<h4', '<h4', '<h4', '</h4', '</h4', '</h4'),
										$op_tmp_output);

			if (($op_sourceformat == 'txt') || ($op_sourceformat == 'fullhtml')) {
				$op_tmp_output = '<blockquote id="ext_cont_blockquote" cite="' 
				. $op_ext_url 
				. '">' 
				. $op_tmp_output 
				. '</blockquote>' 
				. "\n";
				$op_copyright_domain = parse_url ($op_ext_url);
				$op_tmp_output.= '<div id="ext_cont_copyright">' 
				. $plugin_tx['remotecontent']['source'] 
				. '<a target="_blank" href="' 
				. $op_copyright_domain['scheme'] 
				. '://' . $op_copyright_domain['host'] 
				. '/">' . $op_copyright_domain['host'] . '</a></div>'
				. "\n";
			}
		} else {
			$op_tmp_output = '<p>HTTP-Code: ' . $op_curl_info['http_code'] . '</p>' . "\n";							// es kommt immer 200 ?
		}

// temp. Ausgabe
//$op_tmp_output.= $op_ext_url . '<br>' . "\n";
//$op_tmp_output.= $op_authtoken . '<br>' . "\n";
//$op_tmp_output.= 'UserAgent: ' . $op_useragent . '<br>' . "\n";
//$op_tmp_output.= 'Format: ' . $op_sourceformat . '<br>' . "\n";
//$op_tmp_output.= "\n";
//$op_tmp_output.= $op_curl_info['total_time'] . '<br>' . "\n";
//$op_tmp_output.= $op_curl_info['url'] . '<br>' . "\n";
//$op_tmp_output.= $op_curl_info['http_code'] . '<br>' . "\n";
// temp. Ausgabe

	$op_output = $op_tmp_output;
	return $op_output;
}

?>